//***********************************************************************************************
//
//    Copyright (c) 2005 Molecular Devices.
//    All rights reserved.
//
//***********************************************************************************************
// MODULE:  ChannelStats.HPP
// PURPOSE: 
// AUTHOR:  BHI  Feb 2005
//

#ifndef INC_CHANNELSTATS_HPP
#define INC_CHANNELSTATS_HPP

#pragma once
#include "\AxonDev\Comp\CommonLib\StdDev.hpp"
#include "\AxonDev\Comp\CommonLib\MinMax.hpp"
#include "\AxonDev\Comp\CommonLib\DataIterator.hpp"

//===============================================================================================
// STRUCT:  ChannelStats
// PURPOSE: Structure to return results from CChannelStats.
//
struct ChannelStats
{
   double dMean;
   double dStdDev;
   short  nMax;
   short  nMin;
   UINT   uCount;

   ChannelStats() { memset(this, 0, sizeof(*this)); }
};

class CChannelStats
{
private:   // Attributes
   MDC_DataIterator    m_Next;
   UINT             m_uInx;
   UINT             m_uSeqLen;

   MDC_StdDev          m_StdDev;
   MDC_MinMax<short>   m_MinMax;

private:   // Unimplemented copy functions.
   CChannelStats(const CChannelStats &);
   const CChannelStats &operator=(const CChannelStats &);

private:   // Private functions

public:    // Public interface
   CChannelStats();
   ~CChannelStats();

   void SetBuffer(MDC_DATABUFFER *pBuffer, UINT uInx, UINT uSeqLen);
   void NewData(UINT uSeq);

   void GetResults(ChannelStats &Stats);
   void Clear();
};

#endif      // INC_CHANNELSTATS_HPP

