// ProtocolDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DD1550B.h"
#include "ProtocolDlg.hpp"
#include ".\protocoldlg.hpp"

// CProtocolDlg dialog

IMPLEMENT_DYNAMIC(CProtocolDlg, CDialog)
CProtocolDlg::CProtocolDlg(CWnd* pParent, Protocol *pProtocol)
: CDialog(CProtocolDlg::IDD, pParent)
{
	m_pProtocol = pProtocol;
	m_szPath[0] = '\0';
	MDC_GetDefaultDataDirectory(m_szPath, ELEMENTS_IN(m_szPath));
}

CProtocolDlg::~CProtocolDlg()
{
}


void CProtocolDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_PERIOD, m_pProtocol->dSequencePeriodUS);

	DDV_MinMaxDouble(pDX, m_pProtocol->dSequencePeriodUS,m_pProtocol->dMinSequencePeriodUS, m_pProtocol->dMaxSequencePeriodUS); // 4 NST Set Minimum Sequence and Maximum Sequence period  req 3

	DDX_Text(pDX, IDC_TERMINAL_COUNT, m_pProtocol->uTerminalCount);

	DDX_CheckBitFlag(pDX, IDC_EXT_START, m_pProtocol->uFlags, DD1550B_FLAG_EXT_TRIGGER);
	DDX_CheckBitFlag(pDX, IDC_TAG_ENABLE, m_pProtocol->uFlags, DD1550B_FLAG_TAG_BIT0);
	DDX_CheckBitFlag(pDX, IDC_STOP_ON_TC, m_pProtocol->uFlags, DD1550B_FLAG_STOP_ON_TC);

	DDX_CheckBool(pDX, IDC_SAVE_AI, m_pProtocol->bSaveAI);
	DDX_CheckBool(pDX, IDC_SAVE_AO, m_pProtocol->bSaveAO);
	DDX_CheckBool(pDX, IDC_DI, m_pProtocol->bDIEnable);
	DDX_CheckBool(pDX, IDC_DO, m_pProtocol->bDOEnable);
	DDX_CheckBool(pDX, IDC_MONITOR_AI, m_pProtocol->bMonitorAI);

	BOOL abAI[DD1550B_MAX_AI_CHANNELS] = { 0 }, abAO[DD1550B_MAX_AO_CHANNELS] = { 0 };
	if (!pDX->m_bSaveAndValidate)
	{
		for (UINT i=0; i<m_pProtocol->uAIChannels; i++)
			abAI[m_pProtocol->anAIChannels[i]] = true;
		for (UINT i=0; i<m_pProtocol->uAOChannels; i++)
			abAO[m_pProtocol->anAOChannels[i]] = true;
	}

	for (UINT i=0; i<ELEMENTS_IN(abAI); i++)
		DDX_Check(pDX, IDC_AI0+i, abAI[i]);
	for (UINT i=0; i<ELEMENTS_IN(abAO); i++)
		DDX_Check(pDX, IDC_AO0+i, abAO[i]);

	if (pDX->m_bSaveAndValidate)
	{
		m_pProtocol->uAIChannels = 0;
		for (UINT i=0; i<ELEMENTS_IN(abAI); i++)
			if (abAI[i])
				m_pProtocol->anAIChannels[m_pProtocol->uAIChannels++] = i;

		m_pProtocol->uAOChannels = 0;
		for (UINT i=0; i<ELEMENTS_IN(abAO); i++)
			if (abAO[i])
				m_pProtocol->anAOChannels[m_pProtocol->uAOChannels++] = i;

		if (m_pProtocol->uAIChannels == 0)
		{
			pDX->PrepareEditCtrl(IDC_AI0);
			AfxMessageBox("At least one AI channel must be selected", MB_ICONEXCLAMATION);
			pDX->Fail();
		}
	}

	DDX_CheckBitFlag(pDX, IDC_SCOPE_OUT, m_pProtocol->uFlags, DD1550B_FLAG_SCOPE_OUT);
	DDX_CheckBool(pDX, IDC_SCOPEOUT_POLARITY, m_pProtocol->bScopeOutPolarity);
	DDX_Text(pDX, IDC_SCOPEOUT_CHANNEL,    m_pProtocol->nScopeOutAIChannel);
	DDX_Text(pDX, IDC_SCOPEOUT_THRESHOLD,  m_pProtocol->nScopeOutThreshold);
	DDX_Text(pDX, IDC_SCOPEOUT_HYSTERESIS, m_pProtocol->nScopeOutHysteresis);

	for (UINT i=0; i<DD1550B_MAX_AO_CHANNELS; i++)
		DDX_Radio(pDX, IDC_SINE0+i*4, m_pProtocol->anAOWaveType[i]);

	for (UINT i=0; i<DD1550B_MAX_DO_CHANNELS; i++)
		DDX_Check(pDX, IDC_DO0+i, m_pProtocol->anDOWaveType[i]);

	GetDlgItem(IDC_DO15)->EnableWindow(!(m_pProtocol->uFlags & DD1550B_FLAG_SCOPE_OUT)); // NST to (toggle )update DO 15 status according to digital scope output status  req 2

	DDX_Text(pDX, IDC_OUTPERIOD, m_pProtocol->dOutPeriodMS);
	DDX_Text(pDX, IDC_OUTMAX, m_pProtocol->dOutMaxV);
	DDX_Text(pDX, IDC_OUTMIN, m_pProtocol->dOutMinV);

	/*
	//FB 4620
	//just to test. number of ANC channels cannot be > 1 for 1550A
	//temporary hack to test with 1550 repurposed as 1550A with recalibration
	//1550 always reports m_DeviceInfo.ucANC_Enable = 2
	if (m_pProtocol->nNoOf_ANC_ChannelP > 0)
		m_pProtocol->nNoOf_ANC_ChannelP = 1;
	//end of entry for testing
	*/
	/*
	for(UINT i=0; i<m_pProtocol->nNoOf_ANC_ChannelP; i++)       // NST Disable all ANC channels for Req 4
		GetDlgItem(IDC_ANC0+i)->EnableWindow(1);
	

	if(m_pProtocol->nNoOf_ANC_ChannelP)
	{
		GetDlgItem(IDC_STATIC_ANC_Enable)->ShowWindow(1);
	}
	else
	{
		GetDlgItem(IDC_STATIC_ANC_Enable)->ShowWindow(0);
	}
	*/

	for(UINT i=0;i<DD1550B_MAX_ANC_CHANNELS;i++)           // NST Disable all ANC channels for Req 4
		GetDlgItem(IDC_ANC0+i)->ShowWindow(1);

	for(UINT i=0;i<DD1550B_MAX_ANC_CHANNELS;i++)           // NST Disable all ANC channels for Req 4
		GetDlgItem(IDC_ANC0+i)->EnableWindow(0);

    switch (m_pProtocol->nNoOf_ANC_ChannelP)
	{
		case 8:
			GetDlgItem(IDC_ANC0+1)->EnableWindow(1);
			GetDlgItem(IDC_ANC0+3)->EnableWindow(1);
			GetDlgItem(IDC_ANC0+5)->EnableWindow(1);
			GetDlgItem(IDC_ANC0+7)->EnableWindow(1);

		case 4:
			GetDlgItem(IDC_ANC0+4)->EnableWindow(1);
			GetDlgItem(IDC_ANC0+6)->EnableWindow(1);

		case 2:
			GetDlgItem(IDC_ANC0+2)->EnableWindow(1);

		case 1:
			GetDlgItem(IDC_ANC0)->EnableWindow();
			break;
	}


	bool isANC_Selected = false;

	switch (m_pProtocol->nNoOf_ANC_ChannelP)
	{
		case 8:
		case 1:

			for(UINT i=0, unChIndx = 0;i<m_pProtocol->nNoOf_ANC_ChannelP;i++, unChIndx++)
			{	
				DDX_Check(pDX,IDC_ANC0+unChIndx,m_pProtocol->anANCEnable[unChIndx]); // NST  check ANC feature as per the selection Req 4
				if(m_pProtocol->anANCEnable[unChIndx]!=0)
					isANC_Selected=true;
			}
			break;

		case 4:
		case 2:
			for(UINT i=0, unChIndx = 0; i < m_pProtocol->nNoOf_ANC_ChannelP; i++, unChIndx+=2)
			{	
				DDX_Check(pDX,IDC_ANC0+unChIndx,m_pProtocol->anANCEnable[unChIndx]); // NST  check ANC feature as per the selection Req 4
				if(m_pProtocol->anANCEnable[unChIndx]!=0)
					isANC_Selected=true;
			}
	}
	
	
	DDX_CBIndex(pDX,IDC_COMBO_NumOfAvgCycle,m_pProtocol->uNoOfAvgCycle);



}


BEGIN_MESSAGE_MAP(CProtocolDlg, CDialog)
	ON_BN_CLICKED(IDC_SETALL, OnBnClickedSetall)
	ON_BN_CLICKED(IDC_CLEAR, OnBnClickedClear)
	ON_BN_CLICKED(IDC_LOAD, OnBnClickedLoad)
	ON_BN_CLICKED(IDC_SAVE, OnBnClickedSave)
	ON_BN_CLICKED(IDC_INIT, OnBnClickedInit)
	ON_BN_CLICKED(IDC_DO_LOW, OnBnClickedDoLow)
	ON_BN_CLICKED(IDC_DO_HIGH, OnBnClickedDoHigh)
	ON_BN_CLICKED(IDC_DO_SQUARE, OnBnClickedDoSquare)
	ON_BN_CLICKED(IDC_SCOPE_OUT, OnBnClickedScopeOut)
	
END_MESSAGE_MAP()


// CProtocolDlg message handlers
void CProtocolDlg::OnBnClickedSetall()
{
	for (UINT i=0; i<DD1550B_MAX_AI_CHANNELS; i++)
		CheckDlgButton(IDC_AI0+i, true);

	CheckDlgButton(IDC_DI, true);
}

void CProtocolDlg::OnBnClickedClear()
{
	for (UINT i=0; i<DD1550B_MAX_AI_CHANNELS; i++)
		CheckDlgButton(IDC_AI0+i, false);

	CheckDlgButton(IDC_DI, false);
}

const char c_szFilter[] = "Protocol Files (*.pro)|*.pro||";

void CProtocolDlg::OnBnClickedLoad()
{
	DWORD dwFlags = OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST;
	CFileDialog Dlg(true, "pro", m_szPath, dwFlags, c_szFilter, this);

	if (!Dlg.DoModal())
		return;

	CString sFilename = Dlg.GetFileName();
	MDC_strncpyz(m_szPath, sFilename);

	Protocol P;
	P.Load(m_szPath);

	Protocol *pSave = m_pProtocol;
	m_pProtocol = &P;
	UpdateData(false);
	m_pProtocol = pSave;
}

void CProtocolDlg::OnBnClickedSave()
{
	DWORD dwFlags = OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST;
	CFileDialog Dlg(false, "pro", m_szPath, dwFlags, c_szFilter, this);

	if (!Dlg.DoModal())
		return;

	CString sFilename = Dlg.GetFileName();
	MDC_strncpyz(m_szPath, sFilename);

	Protocol P;
	Protocol *pSave = m_pProtocol;
	m_pProtocol = &P; 
	m_pProtocol->nNoOf_ANC_ChannelP = pSave->nNoOf_ANC_ChannelP; // NST to set value of No of ANC Channel as per device send
	UpdateData(true);
	m_pProtocol = pSave;

	P.Save(m_szPath);
}

void CProtocolDlg::OnBnClickedInit()
{
	Protocol P;
	Protocol *pSave = m_pProtocol;
	m_pProtocol = &P;
	m_pProtocol->nNoOf_ANC_ChannelP = pSave->nNoOf_ANC_ChannelP; // NST to set value of No of ANC Channel as per device send 
	UpdateData(false);
	m_pProtocol = pSave;
}

void CProtocolDlg::OnBnClickedDoLow()
{
	for (UINT i=0; i<DD1550B_MAX_DO_CHANNELS; i++)
		CheckDlgButton(IDC_DO0+i, 0);


}

void CProtocolDlg::OnBnClickedDoHigh()
{
	for (UINT i=0; i<DD1550B_MAX_DO_CHANNELS; i++)
		CheckDlgButton(IDC_DO0+i, 1);
	if(m_pProtocol->uFlags & DD1550B_FLAG_SCOPE_OUT  )
	{
		CheckDlgButton(IDC_DO15,0);
	}
}

void CProtocolDlg::OnBnClickedDoSquare()
{
	for (UINT i=0; i<DD1550B_MAX_DO_CHANNELS; i++)
		CheckDlgButton(IDC_DO0+i, 2);

	if(m_pProtocol->uFlags & DD1550B_FLAG_SCOPE_OUT )
	{
		CheckDlgButton(IDC_DO15,0);
	}
}
// FUNCTION: OnBnClickedScopeOut
// PURPOSE:  Toggle the state of IDC_DO15 based on selection of scope check box.

void CProtocolDlg::OnBnClickedScopeOut()
{
	if( ((m_pProtocol->uFlags) & DD1550B_FLAG_SCOPE_OUT) !=0)    // NST to (toggle )update DO 15 status according to digital scope output status  req 2
	{
		m_pProtocol->uFlags &= (~DD1550B_FLAG_SCOPE_OUT);
		GetDlgItem(IDC_DO15)->EnableWindow(1);

	}
	else
	{
		m_pProtocol->uFlags |= DD1550B_FLAG_SCOPE_OUT;
		GetDlgItem(IDC_DO15)->EnableWindow(0);
	}

}




