// ChooseDeviceDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DD1550B.h"
#include "ChooseDeviceDlg.hpp"
#include "\AxonDev\Comp\CommonLib\WaitCursor.hpp"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

const UINT WM_FILL_LIST = WM_APP+200;

#include "\AxonDev\Comp\DriversUSB2\AxDD1550B\AxDD1550B.h"

const LPCSTR c_aszColHeading[] = 
{
	"No.", 
		"Serial", 
		"Firmware", 
		"Name", 
};

/////////////////////////////////////////////////////////////////////////////
// CChooseDeviceDlg dialog


CChooseDeviceDlg::CChooseDeviceDlg(CWnd* pParent, UINT uDevices)
: CDialog(CChooseDeviceDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CChooseDeviceDlg)
	// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	m_bInit        = false;
	m_uDevices     = uDevices;
	m_uSerial      = 0;
	m_uFirstChannel= 0;
	m_nDeviceError = 0;
}

void CChooseDeviceDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CChooseDeviceDlg)
	DDX_Control(pDX, IDC_LIST, m_List);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CChooseDeviceDlg, CDialog)
	//{{AFX_MSG_MAP(CChooseDeviceDlg)
	ON_NOTIFY(NM_DBLCLK, IDC_LIST, OnDblclkList)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChooseDeviceDlg message handlers

void CChooseDeviceDlg::OnDblclkList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	OnOK();
	*pResult = 0;
}

void CChooseDeviceDlg::OnOK() 
{
	// TODO: Add extra validation here
	if (!m_List.GetSelectedCount())
	{
		MessageBeep(UINT(-1));
		return;
	}

	m_uSerial = m_List.GetItemData(m_List.GetNextItem(-1, LVNI_SELECTED));

	CDialog::OnOK();
}

BOOL CChooseDeviceDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_bInit = false;
	m_List.SetExtendedStyle(m_List.GetExtendedStyle() | LVS_EX_FULLROWSELECT);

	for (UINT i=0; i<ELEMENTS_IN(c_aszColHeading); i++)
		m_List.InsertColumn(i, c_aszColHeading[i]);

	for (UINT i=0; i<ELEMENTS_IN(c_aszColHeading); i++)
		m_List.SetColumnWidth(i, LVSCW_AUTOSIZE_USEHEADER);

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CChooseDeviceDlg::OnPaint() 
{
	CPaintDC dc(this); // device context for painting

	if (!m_bInit)
		PostMessage(WM_FILL_LIST);
	m_bInit = true;
}

bool CChooseDeviceDlg::FillList()
{
	CWaitCursor Wait;

	CArrayPtrEx<DD1550B_Info> pDevices;
	if (!pDevices.Alloc(m_uDevices))
		return false;

	UINT uDevices = DD1550B_FindDevices(pDevices, pDevices.GetCount(), &m_nDeviceError);

	GetDlgItem(IDC_WAIT_MSG)->ShowWindow(SW_HIDE);

	if (!uDevices)
		return m_nDeviceError ? ShowDeviceError() : false;

	for (UINT i=0; i<uDevices; i++)
	{
		CString sDevice, sSerialNumber, sProductID;
		sDevice.Format("%d", i);

		// Insert the item
		m_List.InsertItem(i, sDevice);
		m_List.SetItemData(i, pDevices[i].uSerialNumber);

		sSerialNumber.Format("%d", pDevices[i].uSerialNumber);
		sProductID.Format("%d (0x%04X)", pDevices[i].wProductID, pDevices[i].wProductID);

		m_List.SetItemText(i, 1, sSerialNumber);
		m_List.SetItemText(i, 2, pDevices[i].szFirmwareVersion);
		m_List.SetItemText(i, 3, pDevices[i].szName);
	}
	for (UINT i=0; i<ELEMENTS_IN(c_aszColHeading); i++)
		m_List.SetColumnWidth(i, LVSCW_AUTOSIZE_USEHEADER);

	return true;
}

bool CChooseDeviceDlg::ShowDeviceError()
{
	char sz[256] = "";
	DD1550B_GetErrorText(m_nDeviceError, sz, ELEMENTS_IN(sz));
	MessageBox(sz, "Error");
	return false;
}

LRESULT CChooseDeviceDlg::DefWindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	if (message == WM_FILL_LIST)
		FillList();

	return CDialog::DefWindowProc(message, wParam, lParam);
}
