//***********************************************************************************************
//
//    Copyright (c) 2005 Molecular Devices.
//    All rights reserved.
//
//***********************************************************************************************
// MODULE:  Protocol.HPP
// PURPOSE: 
// AUTHOR:  BHI  Feb 2005
//

#ifndef INC_PROTOCOL_HPP
#define INC_PROTOCOL_HPP

#pragma once
#include "\AxonDev\Comp\DriversUSB2\AxDD1550B\AxDD1550B.h"

const int c_nAOSine    = 0;
const int c_nAORamp    = 1;
const int c_nAOZero    = 2;
const int c_nAOSquare  = 3;

const int c_nDOLow     = 0;
const int c_nDOHigh    = 1;
const int c_nDOWave    = 2;

struct Protocol : public DD1550B_Protocol
{
   double adAOHolding[DD1550B_MAX_AO_CHANNELS];
   int    anAOWaveType[DD1550B_MAX_AO_CHANNELS];
   int    anDOWaveType[DD1550B_MAX_DO_CHANNELS];
   double dOutPeriodMS;
   double dOutMaxV;
   double dOutMinV;
   WORD   wDOHolding;
   bool   bMonitorAI;
   int    nNoOf_ANC_ChannelP; //NST Number of ANC Channels
   
   Protocol() { Init(); }
   void Init();
   void Load(LPCSTR pszFilename=NULL);
   void Save(LPCSTR pszFilename=NULL) const;

   UINT GetAIMask() const;
   UINT GetAOMask() const;
};

#endif      // INC_PROTOCOL_HPP

