// stdafx.cpp : source file that includes just the standard includes
// DD1550.pch will be the pre-compiled header
// stdafx.obj will contain the pre-compiled type information

#include "stdafx.h"

int Round(double dVal)
{
	return (int)floor(dVal+0.5);
}

short ClipToShort(double dValue)
{
	if (dValue >= 32767)
		return 32767;
	if (dValue <= -32768)
		return -32768;
	return (short)Round(dValue);
}

bool ClipToChar(double dValue, char &cRval)
{
	if (dValue > 127)
	{
		cRval = 127;
		return false;
	}
	if (dValue < -128)
	{
		cRval = -128;
		return false;
	}
	cRval = (char)Round(dValue);
	return true;
}

void DDX_CheckBool(CDataExchange* pDX, int nIDC, bool& value)
{
	BOOL bValue = value;
	DDX_Check(pDX, nIDC, bValue);
	if (pDX->m_bSaveAndValidate)
		value = (bValue!=0);
}

void DDX_CheckBitFlag(CDataExchange* pDX, int nIDC, UINT& value, UINT uBit)
{
	BOOL bValue = ((value & uBit)!=0);
	DDX_Check(pDX, nIDC, bValue);
	if (pDX->m_bSaveAndValidate)
	{
		if (bValue)
			value |= uBit;
		else
			value &= ~uBit;
	}
}

void DDX_CheckBitFlag(CDataExchange* pDX, int nIDC, WORD& value, WORD wBit)
{
	BOOL bValue = ((value & wBit)!=0);
	DDX_Check(pDX, nIDC, bValue);
	if (pDX->m_bSaveAndValidate)
	{
		if (bValue)
			value |= wBit;
		else
			value &= ~wBit;
	}
}

//===============================================================================================
// FUNCTION: DDX_TextFormat
// PURPOSE:  .
//
void DDX_TextFormat(CDataExchange* pDX, int nIDC, double &value, int nSizeGcvt)
{
	pDX->PrepareEditCtrl(nIDC);

	HWND hWndCtrl=NULL;
	pDX->m_pDlgWnd->GetDlgItem(nIDC, &hWndCtrl);

	char szBuffer[256]="";
	if (pDX->m_bSaveAndValidate)
	{
		::GetWindowText(hWndCtrl, szBuffer, ELEMENTS_IN(szBuffer));
		if (sscanf(szBuffer, _T("%lf"), &value) != 1)
		{
			AfxMessageBox(AFX_IDP_PARSE_REAL);
			pDX->Fail();            // throws exception
		}
	}
	else
	{
		//VAL_ConvertDblToStr( value, szBuffer, ELEMENTS_IN(szBuffer), VAL_FMT_SIG_DIGITS, 
		//                     nSizeGcvt, nSizeGcvt, NULL);

		MDC_sprintf(szBuffer, ELEMENTS_IN(szBuffer), "%.*g", nSizeGcvt, value);
		::SetWindowText(hWndCtrl, szBuffer);
	}
}

